/***************************************************************************
 *                           IzhikevichTimeDrivenModel.cpp                 *
 *                           -------------------                           *
 * copyright            : (C) 2015 by Francisco Naveros                    *
 * email                : fnaveros@ugr.es                                  *
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 3 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "../../include/neuron_model/IzhikevichTimeDrivenModel.h"
#include "../../include/neuron_model/VectorNeuronState.h"

#include <iostream>
#include <cmath>
#include <string>

#include "../../include/openmp/openmp.h"

#include "../../include/spike/EDLUTFileException.h"
#include "../../include/spike/Neuron.h"
#include "../../include/spike/InternalSpike.h"
#include "../../include/spike/PropagatedSpike.h"
#include "../../include/spike/Interconnection.h"

#include "../../include/simulation/Utils.h"

#include "../../include/openmp/openmp.h"


void IzhikevichTimeDrivenModel::LoadNeuronModel(string ConfigFile) throw (EDLUTFileException){
		FILE *fh;
	long Currentline = 0L;
	fh=fopen(ConfigFile.c_str(),"rt");
	if(fh){
		this->State = (VectorNeuronState *) new VectorNeuronState(N_NeuronStateVariables, true);

		//INTEGRATION METHOD
		this->integrationMethod = LoadIntegrationMethod::loadIntegrationMethod((TimeDrivenNeuronModel *)this, fh, &Currentline, N_NeuronStateVariables, N_DifferentialNeuronState, N_TimeDependentNeuronState);

		this->integrationMethod->SetBiFixedStepParameters(-40.0f,c+5.0f,0.2);

		this->integrationMethod->Calculate_conductance_exp_values();
	}
	fclose(fh);
}

void IzhikevichTimeDrivenModel::SynapsisEffect(int index, Interconnection * InputConnection){
	this->GetVectorNeuronState()->IncrementStateVariableAtCPU(index,N_DifferentialNeuronState+InputConnection->GetType(),InputConnection->GetWeight());
}

//this neuron model is implemented in a milisecond scale.
IzhikevichTimeDrivenModel::IzhikevichTimeDrivenModel(string NeuronTypeID, string NeuronModelID): TimeDrivenNeuronModel(NeuronTypeID, NeuronModelID, MilisecondScale){
		a=0.1f;
		b=0.23f;
		c=-65.0f;
		d=0.2;
		eexc=0.0f;//mV
		einh=-80.0f;//mV
		cm=100;//pF
		inv_cm=1.0f/cm;
		texc=5.0f;//ms
		inv_texc=1.0f/texc;
		tinh=10.0f;//ms
		inv_tinh=1.0f/tinh;

}

IzhikevichTimeDrivenModel::~IzhikevichTimeDrivenModel(void)
{
}

void IzhikevichTimeDrivenModel::LoadNeuronModel() throw (EDLUTFileException){
	this->LoadNeuronModel(this->GetModelID()+".cfg");
}

VectorNeuronState * IzhikevichTimeDrivenModel::InitializeState(){
	return this->GetVectorNeuronState();
}


InternalSpike * IzhikevichTimeDrivenModel::ProcessInputSpike(Interconnection * inter, Neuron * target, double time){
	// Add the effect of the input spike
	this->SynapsisEffect(target->GetIndex_VectorNeuronState(),inter);

	return 0;
}






bool IzhikevichTimeDrivenModel::UpdateState(int index, double CurrentTime){

	
	bool * internalSpike=State->getInternalSpike();


	//float * NeuronState;
	//NeuronState[0] --> v 
	//NeuronState[1] --> u 
	//NeuronState[2] --> gexc 
	//NeuronState[3] --> ginh 

	for (int i = 0; i< State->GetSizeState(); i++){

		float * NeuronState=State->GetStateVariableAt(i);
	
		internalSpike[i]=this->integrationMethod->NextDifferentialEcuationValues(i, NeuronState);

		State->SetLastUpdateTime(i,CurrentTime);
	}

	this->CheckValidIntegration();

	return false;
}




ostream & IzhikevichTimeDrivenModel::PrintInfo(ostream & out){
	//out << "- Leaky Time-Driven Model: " << this->GetModelID() << endl;

	//out << "\tExc. Reversal Potential: " << this->eexc << "V\tInh. Reversal Potential: " << this->einh << "V\tResting potential: " << this->erest << "V" << endl;

	//out << "\tFiring threshold: " << this->vthr << "V\tMembrane capacitance: " << this->cm << "nS\tExcitatory Time Constant: " << this->texc << "s" << endl;

	//out << "\tInhibitory time constant: " << this->tinh << "s\tRefractory Period: " << this->tref << "s\tResting Conductance: " << this->grest << "nS" << endl;

	return out;
}	



void IzhikevichTimeDrivenModel::InitializeStates(int N_neurons, int OpenMPQueueIndex){
	//Initialize neural state variables.
	float Veq=(((b-5.0f)-sqrt((5.0f-b)*(5.0f-b)-22.4f))/0.08f);
	float Ueq=Veq*b;
	float initialization[] = {Veq, Ueq,0.0f,0.0f};
	State->InitializeStates(N_neurons, initialization);

	//Initialize integration method state variables.
	this->integrationMethod->InitializeStates(N_neurons, initialization);
}

bool IzhikevichTimeDrivenModel::EvaluateSpikeCondition(float previous_V, float * NeuronState, int index, float elpasedTimeInNeuronModelScale){
	if (NeuronState[0] > 30.0f){
		NeuronState[0] = this->c;//v
		NeuronState[1] += this->d;//u 
		State->NewFiredSpike(index);
		this->integrationMethod->resetState(index);
		return true;
	}
	return false;
}

void IzhikevichTimeDrivenModel::EvaluateDifferentialEcuation(float * NeuronState, float * AuxNeuronState, int index, float elapsed_time){
	float v=NeuronState[0];
	float u=NeuronState[1];
	float gexc=NeuronState[2];
	float ginh=NeuronState[3];
	
	if (v <= 30.0f){
		//V
		AuxNeuronState[0]=0.04f*v*v + 5*v + 140 - u + (gexc * (this->eexc - v) + ginh * (this->einh - v))*this->inv_cm;
		//u
		AuxNeuronState[1]=a*(b*v - u);
	}else{
		//V
		AuxNeuronState[0]=0;
		//u
		AuxNeuronState[1]=0;
	}
}

void IzhikevichTimeDrivenModel::EvaluateTimeDependentEcuation(float * NeuronState, float elapsed_time, int elapsed_time_index){
	float limit=1e-20;
	float * Conductance_values=this->Get_conductance_exponential_values(elapsed_time_index);
	
	if(NeuronState[N_DifferentialNeuronState]<limit){
		NeuronState[N_DifferentialNeuronState]=0.0f;
	}else{
		NeuronState[N_DifferentialNeuronState]*= Conductance_values[0];
	}
	if(NeuronState[N_DifferentialNeuronState+1]<limit){
		NeuronState[N_DifferentialNeuronState+1]=0.0f;
	}else{
		NeuronState[N_DifferentialNeuronState+1]*= Conductance_values[1];
	}	
}

void IzhikevichTimeDrivenModel::Calculate_conductance_exp_values(int index, float elapsed_time){
	//excitatory synapse.
	Set_conductance_exp_values(index, 0, exp(-elapsed_time*this->inv_texc));
	//inhibitory synapse.
	Set_conductance_exp_values(index, 1, exp(-elapsed_time*this->inv_tinh));
}


int IzhikevichTimeDrivenModel::CheckSynapseTypeNumber(int Type){
	if(Type<N_TimeDependentNeuronState && Type>=0){
		return Type;
	}else{
		cout<<"Neuron model "<<this->GetTypeID()<<", "<<this->GetModelID()<<" does not support input synapses of type "<<Type<<endl;
		return 0;
	}
}




